/*
  prefUtils.js
  0.1
  2004-05-10
  Daniel Lindkvist
  Aaron Spuler
 */

// settings
_DEBUG = true;
AUTO_SET_PREFS = true;

if(_DEBUG) dump("in prefutils\n");


function loadHomePage() {
  var pageUrl = "http://www.spuler.us";
  var windowService = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
  var currentWindow = windowService.getMostRecentWindow("navigator:browser");
  if (currentWindow) {
    try {
      currentWindow.delayedOpenTab(pageUrl);
    } catch(e) { currentWindow.loadURI(pageUrl); }
  }
  else
    window.open(pageUrl);
}



var prefUtils =
{//prefUtils
  onLoad: function(aDialogId)
  {//onLoad: function(aDialogID)
    var aWindow = document.getElementById(aDialogId);
    if(_DEBUG) dump("in onLoad\n");
    if(!aWindow)
    {//if(!aWindow)
      if(_DEBUG) dump("No dialog id supplied?\n");
      return;
    }//end if(!aWindow)
    var prefElements = aWindow.getElementsByAttribute("prefstring", "*");
    if(!prefElements)
    {//if(!prefElements)
      if(_DEBUG) dump("prefElements empty\n");
      return;
    }//(end if(!prefElements)
    for(var i=0; i<prefElements.length; i++)
    {//for(var i=0; i<prefElements.length; i++)
      var prefstring = prefElements[i].getAttribute("prefstring");
      var prefid = prefElements[i].getAttribute("id");
      var preftype = prefElements[i].getAttribute("preftype");
      var elt = prefElements[i].localName;
      var prefdefval = prefElements[i].getAttribute("prefdefval");
      if(!prefdefval)
        prefdefval = "";

      if (!preftype)
      {//if (!preftype)
        if (elt == "textbox")
          preftype = "string";
        else if (elt == "checkbox" || elt == "button")
          preftype = "bool";
        else if (elt == "radiogroup" || elt == "menulist")
          preftype = "int";
      }//end if (!preftype)
      var prefvalue = prefUtils.getPref(preftype, prefstring);
      if(_DEBUG) dump("pref collected: "+ prefvalue+"\n");
      if(_DEBUG) dump("elementtype: "+ elt+"\n");
      if(prefvalue == "!/!ERROR_UNDEFINED_PREF!/!")
      {//if(prefvalue == "!/!ERROR_UNDEFINED_PREF!/!")
        prefvalue = prefdefval;
        if(preftype == "int") prefvalue = parseInt(prefvalue);
        else if(prefvalue == "true") prefvalue = true;
        else if(prefvalue == "false") prefvalue = false;
        if(AUTO_SET_PREFS)
          prefUtils.setPref(preftype, prefstring, prefvalue);
        if(_DEBUG) dump("prefdefval set: "+prefvalue+"\n\n");
      }//end if(prefvalue == "!/!ERROR_UNDEFINED_PREF!/!")
      switch(elt)
      {//switch(elt)
        case "textbox":
          prefElements[i].value = prefvalue;
          break;
        case "checkbox":
          prefElements[i].checked = prefvalue;
          break;
        case "button":
          prefElements[i].checked = prefvalue;
          break;
        case "radiogroup":
          prefElements[i].value = prefvalue;
          break;
        case "menulist":
          prefElements[i].selectedIndex = prefvalue;
          break;
      }//end switch(elt)
    }//end for(var i=0; i<prefElements.length; i++)
    if(_DEBUG) dump("init finished\n");
  },//end onLoad: function(aDialogId)


  onOK: function(aDialogId)
  {//onOK: function(aDialogId)
    var aWindow = document.getElementById(aDialogId);
    var prefElements = aWindow.getElementsByAttribute("prefstring", "*");

    for(var i=0; i<prefElements.length; i++)
    {//for(var i=0; i<prefElements.length; i++)
      var prefstring = prefElements[i].getAttribute("prefstring");
      var preftype = prefElements[i].getAttribute("preftype");

      var elt = prefElements[i].localName;
      if (!preftype)
      {//if (!preftype)
        if (elt == "textbox")
          preftype = "string";
        else if (elt == "checkbox" || elt == "button")
          preftype = "bool";
        else if (elt == "radiogroup" || elt == "menulist")
          preftype = "int";
      }//end if(!preftype)
      var prefvalue; 
      if (elt == "checkbox")
        prefvalue = prefElements[i].checked;
      else if (elt == "button")
        prefvalue = prefElements[i].checked;
      else if (elt == "radiogroup" || elt == "menulist")
        prefvalue = prefElements[i].selectedIndex;
      else if (elt == "textbox")
        prefvalue = prefElements[i].value;

      prefUtils.setPref(preftype, prefstring, prefvalue);
      if(_DEBUG) dump("setpref:" +prefstring+" "+ prefvalue + "\n");
    }//end for(var i=0; i<prefElements.length; i++)
    return true;
  },// end onOk


  getPref: function(aPrefType, aPrefString)
  {//getPref: function(aPrefType, aPrefString
    if(_DEBUG) dump("in getpref\n");
    var pref = Components.classes["@mozilla.org/preferences-service;1"]
        .getService(Components.interfaces.nsIPrefBranch);
    try
    {//try
      switch(aPrefType)
      {//switch(aPrefType)
        case "bool":
          return pref.getBoolPref(aPrefString);
        case "int":
          return pref.getIntPref(aPrefString);
        case "localizedstring":
          return pref.getLocalizedUnicharPref(aPrefString); // not working?
        case "color":
        case "string":
        default:
          return pref.getCharPref(aPrefString); 
      }//end switch(aPrefType)
    }//end try
    catch(e)
    {//catch(e)
      if(_DEBUG)
      {//if(_DEBUG)
        dump("*** no default pref for " + aPrefType + " pref: " + aPrefString + "\n");
        dump(e + "\n");
      }//end if(_DEBUG)
    }//end catch(e)
    return "!/!ERROR_UNDEFINED_PREF!/!";
  },//end getPref: function(aPrefType, aPrefString)


  setPref: function(aPrefType, aPrefString, aValue)
  {//setPref: function(aPrefType, aPrefString, aValue)
    var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
    try
    {//try
      switch (aPrefType)
      {//switch (aPrefType)
        case "bool":
          pref.setBoolPref(aPrefString, aValue);
          break;
        case "int":
          pref.setIntPref(aPrefString, aValue);
          break;
        case "color":
        case "string":
        case "localizedstring":
        default:
          pref.setCharPref(aPrefString, aValue);
          break;
      }//end switch (aPrefType)
    }//end try
    catch(e)
    {//catch(e)
      if(_DEBUG) dump(e + "\n");
    }//end catch(e)
  }//end setPref: function(aPrefType, aPrefString, aPrefVaule)
};//end prefUtils