/*
 singlewindow.js 0.3
 Daniel Lindkvist
 Aaron Spuler
 04-07-03
*/

var DEBUG = true;

var orig_contentAreaClick;
var orig_BrowserOpenTab;
var orig_Startup = window.Startup;
var singwininit = false;
var singwin_firefox = false;

if(DEBUG) dump("Syntax ok\n");

////// WindowQ//////////
// moz1.3.1 doesn't do anything if the listener isn't set to capture
//   -- further, we can't remove a listener if it has inline-code.
function wqClickParse(evt)
{
  if (evt.originalTarget.ownerDocument && !evt.originalTarget.ownerDocument.defaultView.wqMainWindow)
    singwin.parseFrames(evt.originalTarget.ownerDocument.defaultView.top);
} // replace window.open() for all (sub)contexts

function wqLoadParse(evt)
{
  if (evt.originalTarget.defaultView && !evt.originalTarget.defaultView.wqMainWindow)
    singwin.parseFrames(evt.originalTarget.defaultView.top);
} // replace window.open() for all (sub)contexts
/////////////////////////

var singwin =
{//var singwin
  pref: null,
  firefox: false,

  init: function()
  {//init
    if(singwininit) return;

    // check for firefox
    try
    {//try
      singwin_firefox = (markLinkVisited != null);
    }//end try
    catch(e)
    {//catch
    singwin_firefox = false;
    }//end catch

    // mozilla
    orig_contentAreaClick = window.contentAreaClick;
    if(singwin_firefox)
    {//if(singwin_firefox)
      window.contentAreaClick = singwin.ffox_contentAreaClick;
      orig_BrowserOpenTab = window.BrowserOpenTab;
      window.BrowserOpenTab = singwin.BrowserOpenTab;
      if(DEBUG) dump("firefox\n");
    }//end if(singwin_firefox)
    else
    {//else
      window.contentAreaClick = singwin.contentAreaClick;
      if(DEBUG) dump("mozilla\n");
    }//end else
    window.Startup = singwin.Startup;

    // set defaultprefs
    pref = singwin.getPref();
    if(!pref.prefHasUserValue("singlewindow.openintabs"))
    {//if(!pref.prefHasUserVaule("singlewindow.openintabs"))
      pref.setBoolPref("singlewindow.openintabs", true);
      pref.setBoolPref("singlewindow.openexternal", true);
    }//end if(!pref.prefHasUserVaule("singlewindow.openintabs"))

/////////// WindowQ /////////////
    window.wqMainWindow = true;
    window.addEventListener('load', wqLoadParse, true); // remove startup-listener -- only run once
    window.getBrowser().addEventListener("mousedown", wqClickParse, true); // user-click listener
    // pref-override
    singwin.setPrefs(); // set built-in suppression prefs
////////////////////////////////

    singwininit = true;
  },//end init

  getPref: function()
  {//getPref
    if(! singwin.pref)
      return singwin.pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
    else
      return singwin.pref;
  },//end getPref


  /**
   * Used in firefox to open new (blank) tabs
   **/
  BrowserOpenTab: function()
  {
    if (pref.getIntPref("browser.tabs.loadOnNewTab") == 1) // use the same pref as mozilla
      gBrowser.selectedTab = gBrowser.addTab(gHomeButton.getHomePage().split("|")[0]);
    else
      orig_BrowserOpenTab();
  },


  /**
   * contentAreaClick for Mozilla
   *
   **/
  contentAreaClick: function(event)
  {
    if(DEBUG) dump("in contentAreaClick\n");
    if(! singwin.getPref().getBoolPref("singlewindow.openintabs"))
      return orig_contentAreaClick(event);

    var isKeyPress = (event.type == "keypress");
    var href = hrefForClickEvent(event);
    if (href)
    {
      if (isKeyPress)
      {
        openNewTabWith(href, true, event.shiftKey);
        event.preventBubble();
      }

      var target = event.target;
      var linkNode = singwin.getLinkNode(event);

      if(singwin.normalClick(event))
      {
        // handle targets
        if(linkNode)
          target = linkNode.getAttribute("target");
        if (!target)
        { //check for basetarget
          var b = document.commandDispatcher.focusedWindow.document.getElementsByTagName("base");
          if (b.length > 0) target = b[0].getAttribute("target");
        }//end if (!target)


        //// From Window-Q, by Rue catches links with invalid targets and open in new tabs. ////
        if (singwin.getPref().getBoolPref("singlewindow.invalidtargets"))
        {
          if (singwin.targetOpensNewStrict(target))
          {
            event.preventDefault();
            openNewTabWith(href, true, event.shiftKey);
            return false;
          }
        }//end if invalidtargets

        //window behavior if the singlewindow.invalidtargets pref is set to false
        if (singwin.targetOpensNew(target)) {
          event.preventDefault();
          openNewTabWith(href, true, event.shiftKey);
          return false;
        }
      }
      handleLinkClick(event, href, null);
      //end single window modifications
      return true;
    }//end if (href)

    if (pref && !isKeyPress && event.button == 1 && !findParentNode(event.originalTarget, "scrollbar") &&
        pref.getBoolPref("middlemouse.contentLoadURL"))
    {
      if (middleMousePaste(event))
      {
        event.preventBubble();
      }
    }
    return true;
  },//end contentAreaClick


  ffox_contentAreaClick: function(event, fieldNormalClicks)
  {
    if(DEBUG) dump("in ffox_contentAreaClick\n");
    if(! singwin.getPref().getBoolPref("singlewindow.openintabs"))
      return orig_contentAreaClick(event, fieldNormalClicks);

    var target = event.target;
    var linkNode = singwin.getLinkNode(event);

    if (linkNode)
    {//if (linkNode)
      if (singwin.normalClick(event))
      {
        target = linkNode.getAttribute("target");
        if (!target)
        {
          // check for basetarget
          var b = document.commandDispatcher.focusedWindow.document.getElementsByTagName("base");
          if (b.length > 0) target = b[0].getAttribute("target");
        }

        if (fieldNormalClicks && (!target || target == "_content" || target  == "_main"))
        { 
          if (!linkNode.href) return true;
          if (linkNode.getAttribute("onclick")) return true;
          var postData = { };
          var url = getShortcutOrURI(linkNode.href, postData);
          if (!url)
            return true;
          markLinkVisited(linkNode.href, linkNode);
          loadURI(url, null, postData.value);
          event.preventDefault();
          return false;
        }

        else if (linkNode.getAttribute("rel") == "sidebar") {
          openDialog("chrome://browser/content/bookmarks/addBookmark2.xul", "",
              "centerscreen,chrome,dialog,resizable,dependent",
              linkNode.getAttribute("title"),
              linkNode.href, null, null, null, null, true);
          event.preventDefault();
          return false;
        }

        else if (target == "_search") {
          openWebPanel(gNavigatorBundle.getString("webPanels"), linkNode.href);
          event.preventDefault();
          return false;
        }

        //invalid targets
        //// From Window-Q, by Rue catches links with invalid targets and open in new tabs. ////
        else if (singwin.getPref().getBoolPref("singlewindow.invalidtargets"))
        {
          if (/*singwin.normalClick(event) && */singwin.targetOpensNewStrict(target)) {
            event.preventDefault();
            openNewTabWith(linkNode.href, linkNode, event, true);
            return false;
          }
        }
        else if (singwin.targetOpensNew(target)) {
          event.preventDefault();
          openNewTabWith(linkNode.href, linkNode, event, true);
          return false;
        }
      }//end if (event.button == 0 && !event.ctrlKey && !event.shiftKey && !event.altKey && !event.metaKey)
    }//end linkNode

    return orig_contentAreaClick(event, fieldNormalClicks);
  }, //end ffox_contentAreaClick


  // returns a valid linkNode if found. Otherwise null.
  getLinkNode: function(event)
  {
    var target = event.target;
    var linkNode;
    var local_name = target.localName;
    if (local_name) {
      local_name = local_name.toLowerCase();
    }
    switch (local_name) {
      case "a":
      case "area":
      case "link":
        if (target.hasAttribute("href"))
          linkNode = target;
        break;
      default:
        linkNode = findParentNode(event.originalTarget, "a");
        if (linkNode && !linkNode.hasAttribute("href"))
          linkNode = null;
        break;
    }
    return linkNode;
  },

  // leftclick with no modifiers?
  normalClick: function(event)
  {
    return ((event.button == 0 && !event.ctrlKey && !event.shiftKey &&
        !event.altKey && !event.metaKey) ? true : false);
  },

  // checks if a target will open in a new window
  // catches all strange variations of _blank Blank _new etc.
  targetOpensNew: function(target)
  {
    if(DEBUG) dump("in targetOpensNew\n");
    if("_new_blank".indexOf(target.toLowerCase()) != -1)
      return true;
    return false;
  },

  // checks if a target will open in a new window, includes invalid targets!
  targetOpensNewStrict: function(target)
  {
    return ((target && "_self_parent_top_main_content".indexOf(target.toLowerCase()) == -1 &&
            ! singwin.targetCheck(document.commandDispatcher.focusedWindow.top, target)) ? true : false);
  },


  //From Window-Q, checks if a link's target matches any document frame
  targetCheck: function(wnd, target)
  {
    if(DEBUG) dump("in targetCheck\n");
    for (var i = 0, match=false; i < wnd.frames.length && !match ; i++)
      match = wnd.frames[i].name == target ||
          ( wnd.frames[i].frames.length > 0
          && this.targetCheck(wnd.frames[i], target) );
    return match;
  },

  Startup: function()
  {
    if(!singwin.getPref().getBoolPref("singlewindow.openintabs") || (!singwin.getPref().getBoolPref("singlewindow.openexternal")))
    {
    //pref.setBoolPref("advanced.system.supportDDEExec", false);
      return orig_Startup();
    }//end if(! singwin.getPref().getBoolPref("singlewindow.openexternal"))

    //pref.setBoolPref("advanced.system.supportDDEExec", true);
    if (!window.opener)
    {
      var windowCount = 0;
      if ("arguments" in window && window.arguments.length > 0 && window.arguments[0])
        var url = window.arguments[0];
      var mediator = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
      var enumerator = mediator.getZOrderDOMWindowEnumerator('navigator:browser',true);

      while (enumerator.hasMoreElements())
      {//while (enumerator.hasMoreElements())
        var w = enumerator.getNext();
        if (windowCount == 1)
          var topWin = w;
        if (++windowCount == 2)
          break;
      }//end while (enumerator.hasMoreElements

      if (windowCount > 1 && url && topWin)
      {//if (windowCount > 1 && url && topWin)
        topWin.focus();
    //topWin.window.openNewTabWith(url, null, null, true); // not used
    var newTab = topWin.window.gBrowser.addTab(url);
    topWin.window.gBrowser.selectedTab = newTab;
        window.close();
        return;
      }//end if (windowCount > 1 && url && topWin
    }//if (!window.opener)
    orig_Startup();
  },//end startup


////////////// from WindowQ ///////////////////
  // Set built-in prefs
  setPrefs: function() {
    singwin.pref.setBoolPref("browser.block.target_new_window", false); // our modified window-open code will handle this
    singwin.pref.setBoolPref("dom.disable_open_during_load", true); // enable popup-suppression
  },

  // Replace window.open for all sub-contexts
  parseFrames: function(wnd)
  {
    if(!singwin.pref.getBoolPref("singlewindow.jslinks"))
      return;
    if (!wnd.wqLoaded) {
      wnd.open = this.dock;
      wnd.wqLoaded = true;
    }
    for (var i=0; i<wnd.frames.length; i++)
      this.parseFrames(wnd.frames[i]); // recurse
  },

  // Dock this window
  dock: function(url, name, flags, arg1, arg2, arg3, arg4, arg5, arg6) {
    var rootBranch = singwin.getPref().getBranch(null);
    var urlObj = Components.classes["@mozilla.org/network/standard-url;1"].createInstance(Components.interfaces.nsIURI);
    var referrerObj = Components.classes["@mozilla.org/network/standard-url;1"].createInstance(Components.interfaces.nsIURI);

    urlObj.spec = url;
    if (!urlObj.scheme || urlObj.scheme == "") {
      if (url.charAt(0) == "/")
        urlObj.spec = this.document.URL.replace(/([^\/])\/(?!\/).*$/, "$1") + url; // root-relative
      else
        urlObj.spec = this.document.URL.replace(/(.*\/)[^\/]+\/?$/, "$1") + url; // local-relative
    }
    //else if (urlObj.scheme == "chrome") { this.WindowQ.openChrome(url, name, flags, arg1, arg2, arg3, arg4, arg5, arg6); return; }
    referrerObj.spec =  this.document.URL; // getReferrer(window.getBrowser().ownerDocument);

    var newTab = window.getBrowser().addTab(urlObj.spec, referrerObj);
    /*if (!rootBranch.getBoolPref("browser.tabs.loadInBackground")) window.getBrowser().selectedTab = newTab; */
    window.getBrowser().selectedTab = newTab;

    if (!newTab.close) {
      // add higher-level "window controls" so our opener can handle us
      newTab.wqObj = {
        close: function() { /*window.getBrowser().removeTab(this);*/ }, // where "this" is the tab we've been called on
        focus: function() { /*window.getBrowser().selectedTab = this;*/ }
      };
      newTab.close = newTab.wqObj.close;
      newTab.focus = newTab.wqObj.focus;
    }
    //newTab.opener = this; // set tab's opener to current (sub)document context

    return newTab; // send back the new tab
  }
////////////////////////////////////////

};//end var singwin
